local MogIt,mog = ...;
local L = mog.L;

local pairs = pairs;

mog.filt = CreateFrame("Frame",nil,mog.frame);
mog.filt:Hide();

mog.filt._minlvl = 0;
mog.filt._maxlvl = UnitLevel("PLAYER");
mog.filt._alliance = UnitFactionGroup("PLAYER") == "Alliance";
mog.filt._horde = UnitFactionGroup("PLAYER") == "Horde";

mog.filt:SetAllPoints(mog.frame.Inset);
mog.filt.lvl = mog.filt:CreateFontString(nil,"ARTWORK","GameFontHighlightSmall");
mog.filt.lvl:SetPoint("TOPLEFT",mog.filt,"TOPLEFT",10,-15);
mog.filt.lvl:SetText(LEVEL_RANGE..":");
mog.filt.lvl:SetWidth(135);
mog.filt.lvl:SetJustifyH("LEFT");

mog.filt.minlvl = CreateFrame("EditBox","MogItFrameMinLvl",mog.filt,"InputBoxTemplate");
mog.filt.minlvl:SetSize(25,16);
mog.filt.minlvl:SetPoint("TOPLEFT",mog.filt,"TOP",10,-15);
mog.filt.minlvl:SetNumeric(true);
mog.filt.minlvl:SetMaxLetters(2);
mog.filt.minlvl:SetNumber(mog.filt._minlvl);
mog.filt.minlvl:SetAutoFocus(false);
mog.filt.minlvl:SetScript("OnEnterPressed",EditBox_ClearFocus);
mog.filt.minlvl:SetScript("OnTabPressed",function(self)
	mog.filt.maxlvl:SetFocus();
end);

mog.filt.lvlh = mog.filt:CreateFontString(nil,"ARTWORK","GameFontHighlightSmall");
mog.filt.lvlh:SetPoint("LEFT",mog.filt.minlvl,"RIGHT",0,1);
mog.filt.lvlh:SetText("-");

mog.filt.maxlvl = CreateFrame("EditBox","MogItFrameMaxLvl",mog.filt,"InputBoxTemplate");
mog.filt.maxlvl:SetSize(25,16);
mog.filt.maxlvl:SetPoint("LEFT",mog.filt.minlvl,"RIGHT",12,0);
mog.filt.maxlvl:SetNumeric(true);
mog.filt.maxlvl:SetMaxLetters(2);
mog.filt.maxlvl:SetNumber(mog.filt._maxlvl);
mog.filt.maxlvl:SetAutoFocus(false);
mog.filt.maxlvl:SetScript("OnEnterPressed",EditBox_ClearFocus);
mog.filt.maxlvl:SetScript("OnTabPressed",function(self)
	mog.filt.minlvl:SetFocus();
end);

mog.filt.faction = mog.filt:CreateFontString(nil,"ARTWORK","GameFontHighlightSmall");
mog.filt.faction:SetPoint("TOPLEFT",mog.filt.lvl,"BOTTOMLEFT",0,-20);
mog.filt.faction:SetText(L["Faction Items:"]);
mog.filt.faction:SetWidth(135);
mog.filt.faction:SetJustifyH("LEFT");

mog.filt.factionAlliance = CreateFrame("CheckButton","MogItFrameFactionAlliance",mog.filt,"UICheckButtonTemplate");
MogItFrameFactionAllianceText:SetText(FACTION_ALLIANCE);
mog.filt.factionAlliance:SetPoint("TOPLEFT",mog.filt.minlvl,"BOTTOMLEFT",-7,-7);
mog.filt.factionAlliance:SetChecked(mog.filt._alliance);
mog.filt.factionAlliance:SetScript("OnClick",function(self)
	mog.filt._alliance = self:GetChecked();
end);

mog.filt.factionHorde = CreateFrame("CheckButton","MogItFrameFactionHorde",mog.filt,"UICheckButtonTemplate");
MogItFrameFactionHordeText:SetText(FACTION_HORDE);
mog.filt.factionHorde:SetPoint("TOPLEFT",mog.filt.factionAlliance,"BOTTOMLEFT",0,5);
mog.filt.factionHorde:SetChecked(mog.filt._horde);
mog.filt.factionHorde:SetScript("OnClick",function(self)
	mog.filt._horde = self:GetChecked();
end);

mog.filt.class = mog.filt:CreateFontString(nil,"ARTWORK","GameFontHighlightSmall");
mog.filt.class:SetPoint("TOPLEFT",mog.filt.faction,"BOTTOMLEFT",0,-52);
mog.filt.class:SetText(L["Class Items:"]);
mog.filt.class:SetWidth(135);
mog.filt.class:SetJustifyH("LEFT");

local classCoords = CLASS_ICON_TCOORDS;
local classColours = RAID_CLASS_COLORS;
mog.classes = {};
FillLocalizedClassList(mog.classes,UnitSex("PLAYER")==3);
mog.classBits = {
	DEATHKNIGHT = 32,
	DRUID = 1024,
	HUNTER = 4,
	MAGE = 128,
	PALADIN = 2,
	PRIEST = 16,
	ROGUE = 8,
	SHAMAN = 64,
	WARLOCK = 256,
	WARRIOR = 1,
};
local classSelected = {[select(2,UnitClass("PLAYER"))] = true};
local classNum = 1;
local classAll = true;
mog.filt._class = mog.classBits[select(2,UnitClass("PLAYER"))];

mog.filt.dd = CreateFrame("Frame","MogItFrameClassDropdown",mog.filt,"UIDropDownMenuTemplate");
mog.filt.dd:SetPoint("TOPLEFT",mog.filt.factionHorde,"BOTTOMLEFT",-18,-5);
UIDropDownMenu_SetWidth(mog.filt.dd,105);
UIDropDownMenu_SetButtonWidth(mog.filt.dd,120);
UIDropDownMenu_JustifyText(mog.filt.dd,"LEFT");
UIDropDownMenu_SetText(mog.filt.dd,L["%d selected"]:format(1));
function mog.filt.dd:initialize()
	local info;
	info = UIDropDownMenu_CreateInfo();
	info.text =	classAll and L["Select All"] or L["Select None"];
	info.value = "SA";
	info.func = function(self)
		classNum = 0;
		for k,v in pairs(mog.classes) do
			classSelected[k] = classAll and true;
			classNum = classNum + (classAll and 1 or 0);
		end
		classAll = not classAll;
		UIDropDownMenu_SetText(mog.filt.dd,L["%d selected"]:format(classNum));
		ToggleDropDownMenu(1,nil,mog.filt.dd);
	end
	info.notCheckable = true;
	UIDropDownMenu_AddButton(info);
	for k,v in pairs(mog.classes) do
		info = UIDropDownMenu_CreateInfo();
		info.text =	v;
		info.value = k;
		info.colorCode = string.format("\124cff%.2x%.2x%.2x",classColours[k].r*255,classColours[k].g*255,classColours[k].b*255);
		info.func = function(self)
			classSelected[self.value] = self.checked;
			classNum = classNum + (self.checked and 1 or -1);
			UIDropDownMenu_SetText(mog.filt.dd,L["%d selected"]:format(classNum));
		end
		info.keepShownOnClick = true;
		info.isNotRadio = true;
		info.checked = classSelected[k];
		info.icon = "Interface\\Glues\\CharacterCreate\\UI-CharacterCreate-Classes";
		info.tCoordLeft = classCoords[k][1];
		info.tCoordRight = classCoords[k][2];
		info.tCoordTop = classCoords[k][3];
		info.tCoordBottom = classCoords[k][4];
		UIDropDownMenu_AddButton(info);
	end
end

mog.filt.source = mog.filt:CreateFontString(nil,"ARTWORK","GameFontHighlightSmall");
mog.filt.source:SetPoint("TOPLEFT",mog.filt.class,"TOPLEFT",0,-32);
mog.filt.source:SetText(L["Source:"]);
mog.filt.source:SetWidth(135);
mog.filt.source:SetJustifyH("LEFT");

mog.filt._sources = {};
local sourceNum = 0;
local sourceAll;
for k,v in ipairs(mog.source) do
	mog.filt._sources[k] = true;
	sourceNum = sourceNum + 1;
end
mog.filt.sources = CreateFrame("Frame","MogItFrameSourcesDropdown",mog.filt,"UIDropDownMenuTemplate");
mog.filt.sources:SetPoint("TOPLEFT",mog.filt.dd,"TOPLEFT",0,-32);
UIDropDownMenu_SetWidth(mog.filt.sources,105);
UIDropDownMenu_SetButtonWidth(mog.filt.sources,120);
UIDropDownMenu_JustifyText(mog.filt.sources,"LEFT");
UIDropDownMenu_SetText(mog.filt.sources,L["%d selected"]:format(sourceNum));
function mog.filt.sources:initialize()
	local info;
	info = UIDropDownMenu_CreateInfo();
	info.text =	sourceAll and L["Select All"] or L["Select None"];
	info.value = "SA";
	info.func = function(self)
		sourceNum = 0;
		for k,v in ipairs(mog.source) do
			mog.filt._sources[k] = sourceAll and true;
			sourceNum = sourceNum + (sourceAll and 1 or 0);
		end
		sourceAll = not sourceAll;
		UIDropDownMenu_SetText(mog.filt.sources,L["%d selected"]:format(sourceNum));
		ToggleDropDownMenu(1,nil,mog.filt.sources);
	end
	info.notCheckable = true;
	UIDropDownMenu_AddButton(info);
	for k,v in ipairs(mog.source) do
		info = UIDropDownMenu_CreateInfo();
		info.text =	v;
		info.value = k;
		info.func = function(self)
			mog.filt._sources[self.value] = self.checked;
			sourceNum = sourceNum + (self.checked and 1 or -1);
			UIDropDownMenu_SetText(mog.filt.sources,L["%d selected"]:format(sourceNum));
		end
		info.keepShownOnClick = true;
		info.isNotRadio = true;
		info.checked = mog.filt._sources[k];
		UIDropDownMenu_AddButton(info);
	end
end

mog.filt.slot = mog.filt:CreateFontString(nil,"ARTWORK","GameFontHighlightSmall");
mog.filt.slot:SetPoint("TOPLEFT",mog.filt.source,"TOPLEFT",0,-32);
mog.filt.slot:SetText(L["One-Hand Slot:"]);
mog.filt.slot:SetWidth(135);
mog.filt.slot:SetJustifyH("LEFT");

mog.filt._slots = {};
local slotNum = 0;
local slotAll;
for k,v in ipairs(mog.slots) do
	mog.filt._slots[k] = true;
	slotNum = slotNum + 1;
end
mog.filt.slots = CreateFrame("Frame","MogItFrameSlotsDropdown",mog.filt,"UIDropDownMenuTemplate");
mog.filt.slots:SetPoint("TOPLEFT",mog.filt.sources,"TOPLEFT",0,-32);
UIDropDownMenu_SetWidth(mog.filt.slots,105);
UIDropDownMenu_SetButtonWidth(mog.filt.slots,120);
UIDropDownMenu_JustifyText(mog.filt.slots,"LEFT");
UIDropDownMenu_SetText(mog.filt.slots,L["%d selected"]:format(slotNum));
function mog.filt.slots:initialize()
	local info;
	info = UIDropDownMenu_CreateInfo();
	info.text =	slotAll and L["Select All"] or L["Select None"];
	info.value = "SA";
	info.func = function(self)
		slotNum = 0;
		for k,v in ipairs(mog.slots) do
			mog.filt._slots[k] = slotAll and true;
			slotNum = slotNum + (slotAll and 1 or 0);
		end
		slotAll = not slotAll;
		UIDropDownMenu_SetText(mog.filt.slots,L["%d selected"]:format(slotNum));
		ToggleDropDownMenu(1,nil,mog.filt.slots);
	end
	info.notCheckable = true;
	UIDropDownMenu_AddButton(info);
	for k,v in ipairs(mog.slots) do
		info = UIDropDownMenu_CreateInfo();
		info.text =	v;
		info.value = k;
		info.func = function(self)
			mog.filt._slots[self.value] = self.checked;
			slotNum = slotNum + (self.checked and 1 or -1);
			UIDropDownMenu_SetText(mog.filt.slots,L["%d selected"]:format(slotNum));
		end
		info.keepShownOnClick = true;
		info.isNotRadio = true;
		info.checked = mog.filt._slots[k];
		UIDropDownMenu_AddButton(info);
	end
end

mog.filt.sorting = mog.filt:CreateFontString(nil,"ARTWORK","GameFontHighlightSmall");
mog.filt.sorting:SetPoint("BOTTOMLEFT",mog.filt,"BOTTOMLEFT",10,18);
mog.filt.sorting:SetText(L["Sorting:"]);
mog.filt.sorting:SetWidth(135);
mog.filt.sorting:SetJustifyH("LEFT");

mog.cR,mog.cG,mog.cB = 255,255,255;
mog.sorting = "level";
mog.filt.sort = CreateFrame("Frame","MogItFrameSortDropdown",mog.filt,"UIDropDownMenuTemplate");
mog.filt.sort:SetPoint("BOTTOMLEFT",mog.filt,"BOTTOM",-14,3);
UIDropDownMenu_SetWidth(mog.filt.sort,105);
UIDropDownMenu_SetButtonWidth(mog.filt.sort,120);
UIDropDownMenu_JustifyText(mog.filt.sort,"LEFT");
UIDropDownMenu_SetText(mog.filt.sort,L["By Level"]);
function mog.filt.sort:initialize()
	local info;
	info = UIDropDownMenu_CreateInfo();
	info.text =	L["By Level"];
	info.value = "level";
	info.func = function(self)
		mog.sorting = self.value;
		UIDropDownMenu_SetText(mog.filt.sort,L["By Level"]);
	end
	info.checked = mog.sorting == "level";
	UIDropDownMenu_AddButton(info);
	
	info = UIDropDownMenu_CreateInfo();
	info.text =	L["By Colour"];
	info.value = "colour";
	info.func = function(self)
		mog.sorting = self.value;
		UIDropDownMenu_SetText(mog.filt.sort,L["By Colour"]);
	end
	info.checked = mog.sorting == "colour";
	info.hasColorSwatch = true;
	info.r = mog.cR/255;
	info.g = mog.cG/255;
	info.b = mog.cB/255;
	info.swatchFunc = function()
		local r,g,b = ColorPickerFrame:GetColorRGB();
		mog.cR,mog.cG,mog.cB = r*255,g*255,b*255;
		mog.sorting = "colour";
		UIDropDownMenu_SetText(mog.filt.sort,L["By Colour"]);
	end
	info.cancelFunc = function(prev)
		mog.cR,mog.cG,mog.cB = prev.r*255,prev.g*255,prev.b*255;
	end
	UIDropDownMenu_AddButton(info);
end

mog.filt.apply = CreateFrame("Button","MogItFrameApply",mog.filt,"UIPanelButtonTemplate2");
mog.filt.apply:SetText(APPLY);
mog.filt.apply:SetSize(120,22);
mog.filt.apply:SetPoint("TOPLEFT",mog.frame.Inset,"BOTTOMLEFT");
mog.filt.apply:SetScript("OnClick",function(self,btn)
	mog.filt.minlvl:ClearFocus();
	mog.filt.maxlvl:ClearFocus();
	mog.filt._minlvl = mog.filt.minlvl:GetNumber();
	mog.filt._maxlvl = mog.filt.maxlvl:GetNumber();
	mog.filt._class = 0;
	for k,v in pairs(classSelected) do
		if v then
			mog.filt._class = mog.filt._class + mog.classBits[k];
		end
	end
	mog.buildList();
end);